//
// Common display definitions
// Functions exports
// Macro definitions
// Common.cpp - implementation
// 
// Author: Jiri Formanek
// Date: 28.5. 2002
//
#include "stdafx.h"

#define DISPLAY_API __declspec(dllexport)

#include  "Common.h"

CDisplay		theDisplay;
CDDFontEngine	theFontEngine;

//
//	Exports function
DISPLAY_API HRESULT disInit(HWND hWnd, UINT uFlags)
{
	return theDisplay.CreateFullScreenSystem(hWnd, uFlags);	
}

DISPLAY_API HRESULT disDefineBackground(COLORREF	crColor)
{
	return theDisplay.DefineBackground(crColor);
}

DISPLAY_API HRESULT disDefineBackground(CString strBMPFile, UINT nFlags)
{
	return theDisplay.DefineBackground(strBMPFile, nFlags);
}

DISPLAY_API HRESULT disBlt(CRect rectDestin, CRect rectSource, CSurface* surSource)
{
	return theDisplay.GetBackSurface()->Blt(rectDestin, rectSource, surSource);			
}

DISPLAY_API HRESULT disBlt(CRect rectDestin, COLORREF crColor)
{
	return theDisplay.GetBackSurface()->Blt(rectDestin, crColor);		
}

DISPLAY_API CSize disGetResolution()
{
	return theDisplay.GetResolution();
}

DISPLAY_API HRESULT	disUpdateBackground()
{
	return theDisplay.UpdateBackground(); 	
}

DISPLAY_API HRESULT  disPresent()
{
	theDisplay.Present();
	return ERROR_SUCCESS;
}

DISPLAY_API HRESULT	 disIncreaseGamma(int d)
{
	return theDisplay.IncrementGamma(d);
}
DISPLAY_API HRESULT	 disDecreaseGamma(int d)
{
	return theDisplay.DecrementGamma(d);
}

DISPLAY_API CDisplay* disGetDisplay()
{
	return &theDisplay;
}

DISPLAY_API HRESULT  fntDrawText(int x, int y, CString csText, CString csFont)
{
	return theFontEngine.DrawText(x, y, csText, csFont);
}
DISPLAY_API HRESULT	 fntCreateFont(CString csFontFile, CString csFontName, COLORREF crColor) 
{
	return theFontEngine.CreateFont(csFontFile, csFontName, crColor);
}