//
// Common display definitions
// Functions exports
// Macro definitions
// 
// Author: Jiri Formanek
// Date: 28.5. 2002
//
#ifndef DISPLAY_COMMON_H
	#define DISPLAY_COMMON_H	
	//
	// Include Direct3D headers
	#include <ddraw.h>
		
	#include "..\Common\Common.h"
	//
	// Export/import macros
	#ifndef DISPLAY_API
		#define DISPLAY_API  __declspec( dllimport )
	#endif // DISPLAY_API

	class CDisplay;	
	class CSurface;
	//
	// Flags for CreateFullScreenSystem()
	#define		DDFLG_CLIPPER					0x00000001
	#define		DDFLG_WINDOWMODE				0x00000002
	#define		DDFLG_FULLSCREEN				0x00000004
	#define		DDFLG_GAMMA						0x00000008
	#define		DDFLG_PALETTE					0x00000010
	// Common flags
	#define		DDFLG_FPS						0x00000020
	// Flags for DefineBackground()
	#define		DDFLG_SYSTEM_MEMORY				0x10000000
	#define		DDFLG_VIDEO_MEMORY				0x20000000
	#define		DDFLG_SCROLLING					0x40000000
	#define		DDFLG_SOLID						0x80000000
	#define		DDFLG_COLORKEY					0xF0000000
	//
	// Keys
	// Graphics section
	#define		_S_KEY_WIDTH				_T("ScreenWidth")
	#define		_S_KEY_HEIGHT				_T("ScreenHeight")
	#define		_S_KEY_DEPTH				_T("ScreenDepth")
	#define		_S_KEY_FPS					_T("FPS")
	#define		_S_KEY_USEGAMMA				_T("UseGamma")
	#define		_S_KEY_SHOWVIDMEM			_T("ShowVidMem")

	#include "Surface.h"
	#include "ddfontengine.h"
	#include "Core.h"	

	//exports
	DISPLAY_API HRESULT		disInit(HWND hWnd, UINT uFlags);
	DISPLAY_API HRESULT		disDefineBackground(COLORREF	crColor);
	DISPLAY_API HRESULT		disDefineBackground(CString strBMPFile, UINT nFlags);

	DISPLAY_API HRESULT		disBlt(CRect rectDestin, CRect rectSource, CSurface *surSource);
	DISPLAY_API HRESULT		disBlt(CRect rectDestin, COLORREF crColor);

	DISPLAY_API CSize		disGetResolution(); 
	DISPLAY_API HRESULT		disUpdateBackground();

	DISPLAY_API HRESULT		disPresent();
	DISPLAY_API HRESULT		disDrawText(CString strText, int x = 0, int y = 0, COLORREF crColor = TC_YELLOW, LPTSTR szFontName = NULL,	int iHeight = 100);

	DISPLAY_API HRESULT		disIncreaseGamma(int d = 8);
	DISPLAY_API HRESULT		disDecreaseGamma(int d = 8);
	DISPLAY_API HRESULT		disFlash(DWORD dwFlashTime = 320, DWORD dwUnflashTime = 500);

	DISPLAY_API CDisplay*	disGetDisplay();

	DISPLAY_API HRESULT  fntDrawText(int x, int y, CString csText, CString csFont);
	DISPLAY_API HRESULT	 fntCreateFont(CString csFontFile, CString csFontName, COLORREF crColor = 0);


#endif // DISPLAY_COMMON_H