// Display.h: interface for the CDisplay class.
//
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_DISPLAY_H__9AB86A30_6E2C_4B72_9D6A_A47064BEB0ED__INCLUDED_)
#define AFX_DISPLAY_H__9AB86A30_6E2C_4B72_9D6A_A47064BEB0ED__INCLUDED_

#include	"Surface.h"

//
// FPS refresh rate
#define		FPS_REFRESH_RATE			1000

#define		_C_DEFAULT_SCREENWIDTH		640
#define		_C_DEFAULT_SCREENHEIGHT		480
#define		_C_DEFAULT_SCREENDEPTH		16

#define		_S_LOADING1					_T("\\Graphics\\Backgrounds\\loading1.bmp")

#define		_S_ARIAL_DDF				_T("\\Graphics\\Fonts\\Arial.ddf")
#define		_S_HUMANS_DDF				_T("\\Graphics\\Fonts\\Humanst521 BT.ddf")

#define		_S_FONT_ARIAL				_T("Arial")
#define		_S_FONT_HUMANS				_T("Humans")
//
class CDisplay   
{
private:
	//
	// Objects of DirectDraw
	LPDIRECTDRAW7				m_lpDD;
	LPDIRECTDRAWCLIPPER			m_lpDDClipper;
	LPDIRECTDRAWPALETTE			m_lpDDPalette;
	// Front&back buffer
	CSurface					m_surFront;
	CSurface					m_surBack;
	//
	// Background&scrolling
	CSurface					m_surBackground;
	CRect						m_ScrollRect;	
	CRect						m_BackSource;	
	CString						m_BackBMP;
	COLORREF					m_BackColor;	
	// 
	// Common display flags
	DWORD						m_dwFlags;
	//
	// Information about display mode
	UINT						m_Res_X;
	UINT						m_Res_Y;
	BYTE						m_Depth;
	//
	// Initialization of system
	bool						m_bIsInit;
	//
	// Display FPS counter
	int							m_StartTime;		
	int							m_StopTime;			
	double						m_Frames;			
	CString						m_strFrames;			
	//
	// Gamma control support
	IDirectDrawGammaControl*	m_GammaControl;
	int							m_CurGamma;

public:
	BOOL	IsInit()    {return m_bIsInit;}
	//
	// Create surfaces etc.
	HRESULT CreateFullScreenSystem(HWND hWnd, DWORD dwFlags);
	// 
	// Palette functions
	HRESULT SetPalette();
	//
	// Flipping surfaces
	void Present();
	//
	// Return directdraw objects
	LPDIRECTDRAW7				GetDirectDraw()		{return m_lpDD;}
	CSurface*					GetBackSurface()	{return &m_surBack;}

	// Resolution
	CSize	GetResolution() {return CSize(m_Res_X, m_Res_Y);}
	//
	// Background functions
	HRESULT	DefineBackground(COLORREF	crColor);
	HRESULT	DefineBackground(CString strBMPFile, DWORD dwFlags);
	HRESULT	UpdateBackground();
	//
	// Gamma corection support
	HRESULT		IncrementGamma(int _Amount = 8);
	HRESULT		DecrementGamma(int _Amount = 8);

private:
	HRESULT	UpdateFPS();
	void	Clean();
	BOOL	HasGammaSupport();

public:
	CDisplay();
	~CDisplay();
};


#endif // !defined(AFX_DISPLAY_H__9AB86A30_6E2C_4B72_9D6A_A47064BEB0ED__INCLUDED_)
