//////////////////////////////////////////////////////////////////////
// Surface.h: interface for the CSurface class.
//
// Author: Jiri Formanek
// Date:   22.7. 2002
//////////////////////////////////////////////////////////////////////

#ifndef SURFACE_H
	#define SURFACE_H

	class AFX_EXT_CLASS CSurface  
	{
	private:
		LPDIRECTDRAWSURFACE7		m_lpDDSurface;
		CDisplay					*m_pDisplay;

		BOOL						m_bInit;
		BOOL						m_bColorKey;

		DWORD						m_dwWidth;
		DWORD						m_dwHeight;
		CString						m_csBitmap;

	public:
		//
		// Create functions
		HRESULT						Create(DWORD dwWidth, DWORD dwHeight, UINT nFlags = DDFLG_COLORKEY);
		HRESULT						Create(CString strBMP, UINT nFlags = DDFLG_COLORKEY);
		HRESULT						Create(LPDIRECTDRAWSURFACE7 lpSurface);
		//
		HRESULT						Release();
		HRESULT						Restore(BOOL	bFill = false);
		HRESULT						SetColorKey();
		//
		// Copy bitmap to surface
		HRESULT						CopyBitmap(CString csBitmap);		
		//
		// Inline functions
		LPDIRECTDRAWSURFACE7		GetSurface();
		BOOL						IsInit() {return m_bInit;}
		BOOL						IsColorKey() {return m_bColorKey;}
		DWORD						Width() {return m_dwWidth;}
		DWORD						Height() {return m_dwHeight;}	
		BOOL						IsValid();
		//
		// Blitting functions
		HRESULT Blt(CRect rcDestin, CRect rcSource, CSurface* surSource);
		HRESULT Blt(CRect rcDestin, COLORREF Color);
		//
		// Overloaded operator to return pointer to surface
		operator LPDIRECTDRAWSURFACE7() {return m_lpDDSurface;};

	public:	
		CSurface();
		~CSurface();
	};

#endif // SURFACE_H
