//---------------------------------------------------------------------------
//
//  DDFontEngine - Copyright  2000 Michael Ftsch.
//
//      The DirectDraw Bitmap Font Engine from "Fast Bitmap Fonts
//      for DirectDraw", which can be found at www.mr-gamemaker.com.
//      The tutorial and a TrueType-to-DDF converter are also available at
//      http://www.crosswinds.net/~foetsch
//
//---------------------------------------------------------------------------

#ifndef DDFontEngineH
#define DDFontEngineH

class CDDFontEngine;

class CDDFont
{
	CString  m_csFont;	
    CString  m_csFontFile;
	COLORREF m_crColor;	
	
public:
	CSurface m_lpFontSurf;

    LPBITMAPINFO lpbi;
    LPVOID lpBits;
    TEXTMETRIC TextMetrics;
    ABC ABCWidths[256];
    LOGFONT LogFont;
    int SurfWidth, SurfHeight;
    int CellWidth, CellHeight;
    RECT SrcRects[256];     // Pre-calculated SrcRects for Blt
    int BPlusC[256];
    

	HRESULT CreateFont(CString csFontFile, CString csFontName, COLORREF crColor = 0);
	CString GetFontName() {return m_csFont;}
public:
	CDDFont();
    ~CDDFont();
};
//---------------------------------------------------------------------------

class CDDFontEngine
{
public:
    CDDFontEngine();
    ~CDDFontEngine();

public:
	CPtrArray	m_arFonts;
    CDDFont	*	m_pCurrentFont;

    HRESULT SelectFont(CString csFontName);
    HRESULT DrawText(int x, int y, CString csText, CString csFont);
	HRESULT	CreateFont(CString csFontFile, CString csFontName, COLORREF crColor = 0);
};
//---------------------------------------------------------------------------


#endif //DDFontEngineH

