// GMenu.h: interface for the CGMenu class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GMENU_H__3F07EF96_C3D5_4FCF_9D9C_BF55F8E6304B__INCLUDED_)
#define AFX_GMENU_H__3F07EF96_C3D5_4FCF_9D9C_BF55F8E6304B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef MENU_API
     #define MENU_API __declspec( dllimport )
#endif // MENU_API

#include "gpage.h"

class CGMenu  
{
	//private atributes
private:
	BOOL		m_bInit;
	CPtrArray   m_Pages;
	CGPage      *m_pCurrentPage;

public:
	//callback func.
	MENUPROC	ProcessFunc;

	//public fuc.
public:
	CGPage*		GetCurrentPage() { return m_pCurrentPage;}
	void		SetCurrentPage(DWORD dwID);
	//init menu
	HRESULT		InitMenu(MENUPROC	_ProcessFunc);
	HRESULT		DefineProcessFunc(MENUPROC	_ProcessFunc);
	void		ReleaseMenu();

	//pages
	void		CreatePage(DWORD dwID, CGPage	*_NewPage);
	CGPage*		GetPage(DWORD dwID);

	//general
	void		UpdateMenu();
	void		TestMouseMove(CPoint _Cursor);
	void		TestMouseClick(CPoint _Cursor, UINT		_MouseButton, UINT _ButtonAction);

public:
	CGMenu();
	~CGMenu();

};


MENU_API HRESULT menInitMenu(MENUPROC	_ProcessFunc);
MENU_API void	 menUpdateMenu();
MENU_API void	 menTestMouseMove(CPoint _Cursor);
MENU_API void    menTestMouseClick(CPoint _Cursor, UINT		_MouseButton, UINT _ButtonAction);
MENU_API void    menCreatePage(DWORD dwID, CGPage	*_NewPage);
MENU_API void	 menSetVisiblePage(int PageID);
MENU_API void	 menReleaseMenu();	


#endif // !defined(AFX_GMENU_H__3F07EF96_C3D5_4FCF_9D9C_BF55F8E6304B__INCLUDED_)
