// Sprite.h: interface for the CSprite class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPRITE_H__B0387A11_7748_451A_B2D1_A19C6B7FE3BA__INCLUDED_)
#define AFX_SPRITE_H__B0387A11_7748_451A_B2D1_A19C6B7FE3BA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DAS_NONE		0x0001
#define DAS_POSITION	0x0002
#define DAS_STATE		0x0004

class AFX_EXT_CLASS CSpriteState  
{
	DWORD		m_dwID;
	int			m_iAnimationSpeed;
	int			m_iPhasesCount;
	CSurface	m_surSource;

	// Tile dim
	int			m_iWidth;
	int			m_iHeight;

	// What to do after animation ends
	DWORD		m_dwDoAfterAnimationEnds;
	CPoint		m_ptPoint;
	DWORD		m_dwState;
	
public:
	void		CreateState(DWORD dwID, LPCSTR szSurface, int iAnimationSpeed = 0, int iPhases = 1);
	void		SetDoAfterAnimationEnds(DWORD dwWhatToDo, DWORD dwState, int x, int y);

	//
	// Inline
	DWORD		GetID()						{return m_dwID;}
	int			GetAnimationSpeed()			{return m_iAnimationSpeed;}
	int			GetPhasesCount()			{return m_iPhasesCount;}
	CSurface*	GetSourceSurface()			{return &m_surSource;}
	DWORD		GetDoAfterAnimationEnds()	{return m_dwDoAfterAnimationEnds;}
	CPoint*		GetPosAF()					{return &m_ptPoint;}
	DWORD		GetStateAF()				{return m_dwState;}
	int			GetHeight()					{return m_iHeight;}
	int			GetWidth()					{return m_iWidth;}

public:
	CSpriteState();
	~CSpriteState();

};

class AFX_EXT_CLASS CSprite  
{
protected:
	CPoint			m_ptPos;
	int				m_iVelX;
	int				m_iVelY;
	int				m_iMaxVel;
	CPtrArray		m_arStates;
	CSpriteState*	m_pCurState;
	CRect			m_rcRealRect;

private:
	int	m_iLastUpdate;
	int m_iCurrentPhase;

public:
	HRESULT			DrawSprite(void);
	HRESULT			MoveSprite(void);
	HRESULT			ChangeAnimationPhase(void);

	void			AddState(CSpriteState * pNewState);
	BOOL			DetectCollision(CRect * pCollisionRect);
	//
	// State depent methods
	void			SetState(DWORD dwState);
	void			GetDestin(CRect* rcDestin);
	void			GetSource(CRect* rcSource);	
	void			SetRealRect(int iLeft, int iTop, int iRight, int iBottom);
	void			SetRealRect(CRect * pRealRect);	
	void			GetRealRect(CRect* pRealRect);
	//
	// Inline
	CSpriteState*	GetState()					{return m_pCurState;}	
	void			SetVelX(int VelX)			{m_iVelX = VelX;}
	int				GetVelX(void)				{return m_iVelX;}
	void			SetVelY(int VelY)			{m_iVelY = VelY;}
	int				GetVelY(void)				{return m_iVelY;}
	void			SetMaxVel(int iMaxVel)		{m_iMaxVel = iMaxVel;}
	int				GetMaxVel()					{return m_iMaxVel;}
	void			SetPosition(CPoint ptPos)	{m_ptPos = ptPos;}
	CPoint*			GetPosition(void)			{return &m_ptPos;}	
	//
	// Virtual
	virtual void	UpdateSprite();

public:
	CSprite();
	~CSprite();

};


#endif // !defined(AFX_SPRITE_H__B0387A11_7748_451A_B2D1_A19C6B7FE3BA__INCLUDED_)
