// Input1.h: interface for the CInput class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INPUT1_H__E5BB3BF3_FB26_47A9_AC92_FF6434ACC168__INCLUDED_)
#define AFX_INPUT1_H__E5BB3BF3_FB26_47A9_AC92_FF6434ACC168__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DIRECTINPUT_VERSION 0x800
// Tento hlavickovy soubor je uzivatelsky pridany
#include <dinput.h>

#define KEYDOWN(name, key) (name[key] & 0x80)

#define		MOUSEBUTTON_LEFT					0
#define		MOUSEBUTTON_RIGHT					1

#ifndef INPUT_API
     #define INPUT_API __declspec( dllimport )
#endif // INPUT_API

#define		_S_CURSOR		_T("\\Graphics\\Cursors\\Arrow.bmp")

#include "Cursor.h"

class CInput  
{
	LPDIRECTINPUT8	m_lpDI;
	LPDIRECTINPUTDEVICE8	m_lpDIDKeyboard;
	// Mouse
	LPDIRECTINPUTDEVICE8	m_lpDIDMouse;

	BOOL	m_bInit;
	BOOL	m_bButtonDown;
	//
	// Rozliseni obrazovky
	CSize	m_csResolution; 
	//
	// Souradnice kurzoru
	CPoint	m_ptCursor;

	//
	// Pole pro klavesnici + handling
	BYTE	m_arKeyboard[256]; 
	BOOL	m_IsHandled[256]; 

	//
	// Stavova struktura pro mys + handling (2 tl.)
	DIMOUSESTATE	m_MouseState;
	BOOL			m_bIsMouseHandled[2];

	//
	// Cursor
	CCursor			m_theCursor;
	BOOL			m_bShowCursor;
	
public:
	// Common func.
	HRESULT CreateDirectInputSystem(HINSTANCE hInst, HWND hWnd, CSize csResolution);
	HRESULT	ProcessInput();
	//
	// Cursor function
	HRESULT UpdateCursor();
	void	ShowCursor(BOOL bShow = TRUE) {m_bShowCursor = bShow;}
	CPoint	GetCursor() {return m_ptCursor;}
	//
	// Detection
	BOOL	IsRButtonDown(BOOL _Handling = TRUE);
	BOOL	IsLButtonDown(BOOL _Handling = TRUE);
	BOOL	IsRButtonUp();
	BOOL	IsLButtonUp();
	BOOL	IsKeyDown(int Key, BOOL bHandle);	

	HRESULT RestoreDevices();
	

public:
	CInput();
	virtual ~CInput();

private:	
	void	MoveCursor(int dx, int dy) {m_ptCursor += CPoint(dx, dy);}	
	void Clean();
};


INPUT_API	HRESULT	inpCreateDirectInputSystem(HINSTANCE hInst, HWND hWnd, CSize csResolution);
INPUT_API	HRESULT	inpProcessInput();
INPUT_API	HRESULT	inpUpdateCursor();
INPUT_API   void	inpShowCursor(BOOL bShow = TRUE);
INPUT_API	BOOL	inpIsRButtonDown(BOOL _Handling = TRUE);
INPUT_API	BOOL	inpIsLButtonDown(BOOL _Handling = TRUE);
INPUT_API	BOOL	inpIsRButtonUp();
INPUT_API	BOOL	inpIsLButtonUp();
INPUT_API	BOOL	inpIsKeyDown(int Key, BOOL bHandle);
INPUT_API	HRESULT inpRestoreDevices();	
INPUT_API	CPoint	inpGetCursor();



#endif // !defined(AFX_INPUT1_H__E5BB3BF3_FB26_47A9_AC92_FF6434ACC168__INCLUDED_)
